namespace PkmnLib.Plugin.Gen7.Scripts.Abilities;

/// <summary>
/// Static is an ability that may paralyze attackers using contact moves.
///
/// <see href="https://bulbapedia.bulbagarden.net/wiki/Static_(Ability)">Bulbapedia - Static</see>
/// </summary>
[Script(ScriptCategory.Ability, "static")]
public class Static : Script, IScriptOnIncomingHit
{
    private const int ChanceToParalyze = 30;

    /// <inheritdoc />
    public void OnIncomingHit(IExecutingMove move, IPokemon target, byte hit)
    {
        if (!move.GetHitData(target, hit).IsContact)
            return;

        if (move.Battle.Random.GetInt(0, 100) < ChanceToParalyze)
        {
            EventBatchId batchId = new();
            if (target.SetStatus(ScriptUtils.ResolveName<Status.Paralyzed>(), target, batchId))
            {
                move.Battle.EventHook.Invoke(new AbilityTriggerEvent(target)
                {
                    BatchId = batchId,
                });
            }
        }
    }
}